/*
 * CTU Open Contest 2012
 *
 * Sample solution: Grasshopper
 * Author: Martin Kacer
 * 
 * This version performs a BFS.
 */

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

public class grasshop {
	StringTokenizer st = new StringTokenizer("");
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
	void useLine(String s) { st = new StringTokenizer(s); }
	String nextToken() throws Exception {
		while (!st.hasMoreTokens()) st = new StringTokenizer(input.readLine());
		return st.nextToken();
	}
	int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}
	public static void main(String[] args) throws Exception {
		grasshop instance = new grasshop();
		while (instance.run()) { /*repeat*/ }
	}
	
	static final int MAX = 100, MAX2 = MAX*MAX;
	
	int xx, yy;
	int[] qx = new int[MAX2], qy = new int[MAX2];
	int qb, qe;
	int[][] dist;
	
	void enqueue(int x, int y, int d) {
		if (x < 0 || x >= xx || y < 0 || y >= yy) return;
		if (dist[x][y] != 0) return;
		dist[x][y] = d;
		qx[qe] = x; qy[qe++] = y;
	}

	boolean run() throws Exception {
		String in = input.readLine();
		if (in == null) return false;
		useLine(in);
		xx = nextInt(); yy = nextInt();
		int x1 = nextInt()-1, y1 = nextInt()-1, x2 = nextInt()-1, y2 = nextInt()-1;
		dist = new int[xx][yy];
		qb = qe = 0;
		enqueue(x1, y1, 1);
		while (qb < qe && dist[x2][y2] == 0) {
			int x = qx[qb], y = qy[qb++], d = dist[x][y] + 1;
			enqueue(x+1, y+2, d); enqueue(x+2, y+1, d);
			enqueue(x+1, y-2, d); enqueue(x+2, y-1, d);
			enqueue(x-1, y+2, d); enqueue(x-2, y+1, d);
			enqueue(x-1, y-2, d); enqueue(x-2, y-1, d);
		}
		System.out.println((dist[x2][y2] == 0) ? "impossible" : String.valueOf(dist[x2][y2]-1));
		return true;
	}
}
